﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pacman01_2DArray
{
    class Program
    {
        static string[] mapS = {
            "##############",
            "#..#.###@...##",
            "##.#...#.##..#",
            "##.#.###.#####",
            "##¤..........#",
            "##############"
                              };
        static char[][] map;
        static void Main(string[] args)
        {
            int cols = mapS[0].Length;
            int rows = mapS.Length;
            map = new char[rows][];
            for (int j = 0; j < rows; ++j)
            {
                map[j] = new char[cols];
                for (int i = 0; i < cols; ++i)
                    map[j][i] = mapS[j][i];
            }

            int playerPosX = 0;
            int playerPosY = 0;
            int score = 0;

            //draw level
            for (int i = 0; i < cols; ++i)
            {
                for (int j = 0; j < rows; ++j)
                {
                    System.Console.SetCursorPosition(i, j + 1);
                    char obj = map[j][i];
                    System.Console.Write(obj);
                    if (obj == '¤')
                    {
                        playerPosX = i;
                        playerPosY = j;
                    }
                }
            }
            System.Console.SetCursorPosition(0, 0);
            System.Console.Write("Score: 0");

            while (true)
            {
                if (System.Console.KeyAvailable)
                {
                    ConsoleKeyInfo keyinfo = System.Console.ReadKey(true);
                    int moveX = 0;
                    int moveY = 0;
                    if (keyinfo.Key == ConsoleKey.LeftArrow)
                        moveX = -1;
                    if (keyinfo.Key == ConsoleKey.RightArrow)
                        moveX = 1;
                    if (keyinfo.Key == ConsoleKey.UpArrow)
                        moveY = -1;
                    if (keyinfo.Key == ConsoleKey.DownArrow)
                        moveY = 1;
                    if (keyinfo.Key == ConsoleKey.Escape)
                        System.Environment.Exit(0);

                    int newPosX = playerPosX + moveX;
                    int newPosY = playerPosY + moveY;

                    char obj = map[newPosY][newPosX];
                    if (obj != '#') //not a wall hit
                    {
                        if (obj == '.')
                        {
                            score++;
                            System.Console.SetCursorPosition(0, 0);
                            System.Console.Write("Score: " + score);
                            map[newPosY][newPosX] = ' ';
                        }
                        else if (obj == '@')
                        {
                            System.Console.SetCursorPosition(0, 0);
                            System.Console.Write("GAME OVER");
                            System.Threading.Thread.Sleep(3000);
                            System.Environment.Exit(0);
                        }
                        System.Console.SetCursorPosition(playerPosX, playerPosY + 1);
                        System.Console.Write(" ");

                        playerPosX = newPosX;
                        playerPosY = newPosY;

                        System.Console.SetCursorPosition(playerPosX, playerPosY + 1);
                        System.Console.Write("¤");
                    }
                }
            }
        }
    }
}