﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pacman03_OOP
{
    class Game
    {
        System.Collections.Generic.List<GameObject> mGameObjects = new System.Collections.Generic.List<GameObject>();

        static string[] mapS = {
            "##############",
            "#..#.###@...##",
            "##.#...#.##..#",
            "##.#.###.#####",
            "##¤..........#",
            "##############"
                              };

        public void run()
        {
            Player player = null;
            Mover mover = new Mover();

            int cols = mapS[0].Length;
            int rows = mapS.Length;
            mover.setLevelSize(rows, cols);
            for (int j = 0; j < rows; ++j)
            {
                for (int i = 0; i < cols; ++i)
                {
                    GameObject go = null;

                    if (mapS[j][i] == '#')
                    {
                        go = new Wall();
                        go.position = new Vec2(i, j);
                        mover.addStaticObject(go.position);
                    }
                    else if (mapS[j][i] == '.')
                    {
                        Coin co = new Coin();
                        co.position = new Vec2(i, j);
                        go = co;
                        mover.addGameObject(co);
                    }
                    else if (mapS[j][i] == '¤')
                    {
                        go = player = new Player();
                        go.position = new Vec2(i, j);
                        mover.addGameObject(player);
                    }
                    else if (mapS[j][i] == '@')
                    {
                        Monster mo = new Monster();
                        mover.addGameObject(mo);
                        mo.position = new Vec2(i, j);
                        go = mo;
                    }
                    mGameObjects.Add(go);
                }
            }

            System.Collections.Generic.List<GameObject>.Enumerator et = mGameObjects.GetEnumerator();
            while (et.MoveNext())
            {
                et.Current.draw();
            }
            System.Console.SetCursorPosition(0, 0);
            System.Console.Write("Score: 0");

            while (true)
            {
                et = mGameObjects.GetEnumerator();
                while (et.MoveNext())
                {
                    GameObject go = et.Current;
                    go.update();
                }
                mover.update();

                System.Collections.Generic.List<GameObject> toBeDeleted = new System.Collections.Generic.List<GameObject>();
                et = mGameObjects.GetEnumerator();
                while (et.MoveNext())
                {
                    if (et.Current.destroy)
                        toBeDeleted.Add(et.Current);
                }
                et = toBeDeleted.GetEnumerator();
                while (et.MoveNext())
                {
                    if (et.Current == player)
                        player = null;
                    mGameObjects.Remove(et.Current);
                }

                if (player == null)
                {
                    System.Console.SetCursorPosition(0, 0);
                    System.Console.Write("GAME OVER");
                    System.Threading.Thread.Sleep(3000);
                    System.Environment.Exit(0);
                }
                System.Console.SetCursorPosition(0, 0);
                System.Console.Write("Score: " + player.score);
            }

        }
    }
}
