﻿using System;

namespace ConsolePlatformer
{
    class GameObject
    {
        static int TAG_NONE = 0;
        static int TAG_PLAYER = 1;
        static int TAG_ENEMY = 2;
        static int TAG_COLLECTABE = 3;
        
        public GameObject(Level level)
        {
            mLevel = level;
        }
        public void destroy()
        {
            destroyMark = true;            
        }

        public void finalizeDestroy()
        {
            if (destroyMark)
            {
                System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
                while (et.MoveNext())
                    et.Current.onDestroy();
                mLevel.removeGameObject(this);
            }
        }

        public Level getLevel() { return mLevel; }
        public void onStart()
        {
            System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
            while (et.MoveNext())
                et.Current.onStart();
        }
        public void onPreUpdate()
        {
            System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
            while (et.MoveNext())
                et.Current.onPreUpdate();
        }
        public void onPostUpdate()
        {
            System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
            while (et.MoveNext())
                et.Current.onPostUpdate();
        }
        public void onCollision(Collider other)
        {
            System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
            while (et.MoveNext())
                et.Current.onCollision(other);
        }
        public Component getComponent(String name)
        {
            System.Collections.Generic.List<Component>.Enumerator et = mComponents.GetEnumerator();
            while (et.MoveNext())
                if (et.Current.name.Equals(name))
                    return et.Current;
            return null;
        }

        public Vec2 position = new Vec2();
        public int tag = TAG_NONE;
        public bool destroyMark = false;
        
        protected Level mLevel;
        protected System.Collections.Generic.List<Component> mComponents = new System.Collections.Generic.List<Component>();
    }
}
