﻿using System;

namespace ConsolePlatformer
{
    class LevelLoader
    {
        public virtual void loadLevel(Level level)
        {

        }
    }

    class Level
    {
        System.Collections.Generic.List<GameObject> mLevelObjects = new System.Collections.Generic.List<GameObject>();

        public void start(LevelLoader loader)
        {
            loader.loadLevel(this);

            System.Collections.Generic.List<GameObject>.Enumerator et = mLevelObjects.GetEnumerator();
            while (et.MoveNext())
                et.Current.onStart();
        }
        public void update()
        {
            System.Collections.Generic.List<GameObject>.Enumerator et = mLevelObjects.GetEnumerator();
            System.Collections.Generic.List<GameObject> destroyList = new System.Collections.Generic.List<GameObject>();
            while (et.MoveNext())
                if (et.Current.destroyMark)
                    destroyList.Add(et.Current);
            et = destroyList.GetEnumerator();
            while (et.MoveNext())
                et.Current.finalizeDestroy();
           
            et = mLevelObjects.GetEnumerator();
            while (et.MoveNext())
                et.Current.onPreUpdate();
            
            CollisionHandler.update();
            
            et = mLevelObjects.GetEnumerator();
            while (et.MoveNext())
                et.Current.onPostUpdate();
        }
        public void addGameObject(GameObject gameObject)
        {
            mLevelObjects.Add(gameObject);
        }
        public void removeGameObject(GameObject gameObject)
        {
            mLevelObjects.Remove(gameObject);
        }
    }
}
